﻿local obj = {}
local player

function createPlatform(x, y)
	local body = love.physics.newBody( level, x, y, 'static' )
	local v = love.physics.newChainShape( true, 0, 0, 0, 5, 5, 5, 5, 0 )
	body:setGravityScale( 0 )
	love.physics.newFixture( body, v, 1 )
	  return body
end

function createRamp(x, y)
	local body = love.physics.newBody( level, x, y, 'static' )
	local v = love.physics.newChainShape( true, 5, 0, 0, 5, 5, 5 )
	body:setGravityScale( 0 )
	love.physics.newFixture( body, v, 1 )
	  return body
end

function love.load()
	love.window.setMode(800, 600)
	--love.graphics.setBackgroundColor( 250, 250, 250 )
	level = love.physics.newWorld(0, 9.81, true)
		
		for x = 0, 50, 5 do
			obj[#obj+1] = createPlatform(x, 20)
		end

		for x = 0, 50, 5 do
			obj[#obj+1] = createPlatform(x, 0)
		end		
		
	local x, y = 3, 12
	player = love.physics.newBody( level, x, y, 'dynamic' )
	local pShape = love.physics.newRectangleShape( 5, 10 )
	player:setGravityScale(0)
	player:setFixedRotation(true)
	local fx = love.physics.newFixture( player, pShape, 1 )
	fx:setFriction(0)
	
		
end

function love.update(dt)
	level:update(dt)
	checkInput()
end

local vX, vY = 0, 0

function checkInput(  )
	local sp = 0.7
  if love.keyboard.isDown("up")  then
    player:setLinearVelocity( vX+0, vY-sp )
	vX, vY = vX+0, vY-sp
	--changeMapView( dt )
  end
  if love.keyboard.isDown("down")  then
    player:setLinearVelocity( vX+0, vY+sp )
	vX, vY = vX+0, vY+sp
	--changeMapView( -dt )
  end
  if love.keyboard.isDown("left")  then
    player:setLinearVelocity( vX-sp, vY+0 )
	vX, vY = vX-sp, vY+0
  end
  if love.keyboard.isDown("right")  then
    player:setLinearVelocity( vX+sp, 0 )
	vX, vY = vX+sp, vY+0
  end
  if love.keyboard.isDown("g")  then
    player:setLinearVelocity(0, 0 )
	vX, vY = 0,0
  end 
end

function love.draw()
	for _, body in ipairs( obj ) do
		x1, y1, x2, y2, x3, y3, x4, y4 = body:getWorldPoints( (((body:getFixtureList())[1]):getShape()):getPoints() )
		love.graphics.polygon( 'line', x1*12.8, y1*12.8, x2*12.8, y2*12.8, x3*12.8, y3*12.8, x4*12.8, y4*12.8 )
	end
		x1, y1, x2, y2, x3, y3, x4, y4 = player:getWorldPoints( (((player:getFixtureList())[1]):getShape()):getPoints() )
		love.graphics.polygon( 'line', x1*12.8, y1*12.8, x2*12.8, y2*12.8, x3*12.8, y3*12.8, x4*12.8, y4*12.8 )
end